#!/usr/bin/python
# -*- encoding: utf-8 -*-

# Priklad ovladani obvodu PCA9685: 
# Postupne rozsvecovani a zhasinani LED (plynula zmena stridy signalu)


import time
import smbus



bus = smbus.SMBus(1)   # novejsi varianta RasPi (512MB)
#bus = smbus.SMBus(0)   # starsi varianta RasPi (256MB)

addr = 0x40            # I2C adresa obvodu PCA9685 (kdyz jsou vsechny adresovaci vstupy v "0", je adresa 0x40)


gen=25000000                                   # frekvence vnitrniho generatoru obvodu PCA9685 (25MHz)
frekvence = 1000                               # pozadovana frekvence vystupu v Hz (23.84 az 6103)
kanal = 0                                      # cislo kanalu 0 az 15

n = int((gen /frekvence) / 4096)-1             # prepocet frekvence na pozadovanou konstantu prescaleru (orezava)
nastavena_frekv = gen / (4096.0 * (n+1))       # zpetny vypocet skutecne nastavene frekvence

adr_kan = 6 + (kanal * 4)                      # kazdy kanal se ridi pomomci 4 bajtu. Nulty kanal zacina na adrese 6




print "Skutecne nastavena frekvence:  " + str(nastavena_frekv)  + " (prescaler (0 az 255): " + str(n) + ")"



# inicializace PWM s pouzitim vnitrniho oscilatoru (25MHz)
bus.write_byte_data(addr,0x00,0b00010000)  # SLEEP
bus.write_byte_data(addr,0xFE,n)           # nastaveni frekvence prescaleru
bus.write_byte_data(addr,0x01,0b00010000)  # Logika vystupu: Ledka sviti pri "0" (je zapojena proti VCC)
bus.write_byte_data(addr,0x00,0b00000000)  # spust PWM generator



# casu prechodu z "0" na "1" je pokazde stejny (v case 0)
bus.write_byte_data(addr, adr_kan,     0) # prechod signalu z "0" na "1"  8xLSB
bus.write_byte_data(addr, adr_kan + 1, 0) #                               4xMSB


# Prvni smycka pro postupne zvetsovani sirky od 0 do 4095
for sirka_H in range (4096):

  dolnibajt_H = int(sirka_H % 256)               # prepocet 12-bitove sirky impulzu na horni a dolni bajt
  hornibajt_H = int(sirka_H / 256)

  # postupne nastaveni sirky impulzu
  bus.write_byte_data(addr, adr_kan + 2, dolnibajt_H) #  prechod z "1" na "0" 8xLSB
  bus.write_byte_data(addr, adr_kan + 3, hornibajt_H) #                       4xMSB

  time.sleep(0.001)                       # pauza mezi zmenou sirky
  
# Druha smycka pro postupne zmensovani sirky od 4095 do 0
for sirka_H in range (4095,0,-1):

  dolnibajt_H = int(sirka_H % 256)               # prepocet 12-bitove sirky impulzu na horni a dolni bajt
  hornibajt_H = int(sirka_H / 256)

  # postupne nastaveni sirky impulzu
  bus.write_byte_data(addr, adr_kan + 2, dolnibajt_H) #  prechod z "1" na "0" 8xLSB
  bus.write_byte_data(addr, adr_kan + 3, hornibajt_H) #                       4xMSB

  time.sleep(0.001)                       # pauza mezi zmenou sirky
  


bus.write_byte_data(addr,0x00,0x10)  # zastav PWM generator
  

